      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************

       class-id. MicroFocus.COBOL.Book.Examples.SimpleDate. 

       working-storage section.
       01 Year             binary-long property with no set. 
       01 Month            type Month property with no set.
       01 #Day             binary-long property with no set. 
       
       method-id New(year as binary-long, month as type Month, #day as binary-long).
           if not IsValid(year  month  #day) then
               raise new Exception("Invalid date") 
           end-if
           set self::Year to year
           set self::Month to month
           set self::Day to #Day
       end method. 
       
       method-id DisplayFormat() returning lnkResult as string. 
           set lnkResult to year & "-" & month & "-" & #day
       end method.
       
      *> If dates are the same, result = 0 
      *> If this date is earlier than d2 result = -1 
      *> If this date is later than d2 = +1
       method-id Compare(d2 as type SimpleDate) returning result as binary-long.
           set result to self::Year - d2::Year 
           if result = 0 
               set result to self::Month - d2::Month 
               if result = 0 then   
                   set result to self::Day - d2::Day 
               end-if
           end-if
           set result to function sign (result)
       end method. 
       
       method-id IsValid(year as binary-long month as type Month #day as binary-long ) returning result as condition-value private.
           set result to true 
           if year < 0 or #day < 1 then
               set result to false 
            else
               evaluate month
               when type Month::Jan
               when type Month::Mar
               when type Month::May
               when type Month::Jul
               when type Month::Aug
               when type Month::Oct
               when type Month::Dec
                   if #day > 31 then
                       set result to false
                   end-if
               when type  Month::Apr 
               when type  Month::Jun
               when type  Month::Sep
               when  type Month::Nov
                   if #day > 30 then
                       set result to false
                   end-if
               when type  Month::Feb
                   if IsLeapYear(year) then
                       if #day > 29 
                           set result to false
                       end-if
                   else
                       if #day > 28 
                           set result to false
                       end-if
                   end-if
               when other *> we only get here if someone casts an out of range
                          *> integer into a Month enum. 
                   set result to false
               end-evaluate
               
           end-if
       
       end method. 
           
       method-id IsLeapYear(year as binary-long) returning result as condition-value private.   
           declare modulus as binary-long = function mod(year 4) 
           if modulus = 0 then
               if function mod (year 100) <> 0 then
                   set result to true  
               end-if
           end-if
           set result to false
       end method. 

       enum-id Month. 
      *> Month constants. 
       78 Jan              value 1. 
       78 Feb              value 2. 
       78 Mar              value 3.
       78 Apr              value 4. 
       78 May              value 5.
       78 Jun              value 6.
       78 Jul              value 7.
       78 Aug              value 8.
       78 Sep              value 9.
       78 Oct              value 10. 
       78 Nov              value 11. 
       78 Dec              value 12. 
       end enum.

         
       end class. 
       
  